diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/examples/fd2fd-onoff.cc ns-3.40/src/fd-net-device/examples/fd2fd-onoff.cc
--- ns-3.39/src/fd-net-device/examples/fd2fd-onoff.cc	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/examples/fd2fd-onoff.cc	2023-09-27 13:30:37.646839100 -0700
@@ -64,7 +64,7 @@
     cmd.Parse(argc, argv);
 
     std::string factory;
-    if (tcpMode == 1)
+    if (tcpMode)
     {
         factory = "ns3::TcpSocketFactory";
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/examples/fd-emu-onoff.cc ns-3.40/src/fd-net-device/examples/fd-emu-onoff.cc
--- ns-3.39/src/fd-net-device/examples/fd-emu-onoff.cc	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/examples/fd-emu-onoff.cc	2023-09-27 13:30:37.646839100 -0700
@@ -200,7 +200,7 @@
 #ifdef HAVE_PACKET_H
     if (emuMode == "raw")
     {
-        EmuFdNetDeviceHelper* raw = new EmuFdNetDeviceHelper;
+        auto raw = new EmuFdNetDeviceHelper;
         raw->SetDeviceName(deviceName);
         helper = raw;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/examples/fd-emu-ping.cc ns-3.40/src/fd-net-device/examples/fd-emu-ping.cc
--- ns-3.39/src/fd-net-device/examples/fd-emu-ping.cc	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/examples/fd-emu-ping.cc	2023-09-27 13:30:37.646839100 -0700
@@ -184,7 +184,7 @@
 #ifdef HAVE_PACKET_H
     if (emuMode == "raw")
     {
-        EmuFdNetDeviceHelper* raw = new EmuFdNetDeviceHelper;
+        auto raw = new EmuFdNetDeviceHelper;
         raw->SetDeviceName(deviceName);
         helper = raw;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/examples/fd-emu-send.cc ns-3.40/src/fd-net-device/examples/fd-emu-send.cc
--- ns-3.39/src/fd-net-device/examples/fd-emu-send.cc	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/examples/fd-emu-send.cc	2023-09-27 13:30:37.646839100 -0700
@@ -57,15 +57,15 @@
 
     int packets = 10000000;
 
-    Mac48Address sender = Mac48Address("00:00:00:aa:00:01");
-    Mac48Address receiver = Mac48Address("ff:ff:ff:ff:ff:ff");
+    Mac48Address sender("00:00:00:aa:00:01");
+    Mac48Address receiver("ff:ff:ff:ff:ff:ff");
 
     int packetsSize = 64;
     Ptr<Packet> packet = Create<Packet>(packetsSize);
     EthernetHeader header;
 
     ssize_t len = (size_t)packet->GetSize();
-    uint8_t* buffer = (uint8_t*)malloc(len);
+    auto buffer = (uint8_t*)malloc(len);
     packet->CopyData(buffer, len);
 
     int sent = 0;
@@ -166,7 +166,7 @@
 #ifdef HAVE_PACKET_H
     if (emuMode == "raw")
     {
-        EmuFdNetDeviceHelper* raw = new EmuFdNetDeviceHelper;
+        auto raw = new EmuFdNetDeviceHelper;
         raw->SetDeviceName(deviceName);
         helper = raw;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/examples/fd-emu-tc.cc ns-3.40/src/fd-net-device/examples/fd-emu-tc.cc
--- ns-3.39/src/fd-net-device/examples/fd-emu-tc.cc	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/examples/fd-emu-tc.cc	2023-09-27 13:30:37.646839100 -0700
@@ -168,11 +168,11 @@
 #ifdef HAVE_PACKET_H
     if (emuMode == "raw")
     {
-        EmuFdNetDeviceHelper* raw0 = new EmuFdNetDeviceHelper;
+        auto raw0 = new EmuFdNetDeviceHelper;
         raw0->SetDeviceName(deviceName0);
         helper0 = raw0;
 
-        EmuFdNetDeviceHelper* raw1 = new EmuFdNetDeviceHelper;
+        auto raw1 = new EmuFdNetDeviceHelper;
         raw1->SetDeviceName(deviceName1);
         helper1 = raw1;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/helper/dpdk-net-device-helper.h ns-3.40/src/fd-net-device/helper/dpdk-net-device-helper.h
--- ns-3.39/src/fd-net-device/helper/dpdk-net-device-helper.h	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/helper/dpdk-net-device-helper.h	2023-09-27 13:30:37.646839100 -0700
@@ -21,7 +21,7 @@
 #ifndef DPDK_NET_DEVICE_HELPER_H
 #define DPDK_NET_DEVICE_HELPER_H
 
-#include "ns3/emu-fd-net-device-helper.h"
+#include "emu-fd-net-device-helper.h"
 
 namespace ns3
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/helper/emu-fd-net-device-helper.h ns-3.40/src/fd-net-device/helper/emu-fd-net-device-helper.h
--- ns-3.39/src/fd-net-device/helper/emu-fd-net-device-helper.h	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/helper/emu-fd-net-device-helper.h	2023-09-27 13:30:37.646839100 -0700
@@ -19,8 +19,9 @@
 #ifndef EMU_FD_NET_DEVICE_HELPER_H
 #define EMU_FD_NET_DEVICE_HELPER_H
 
+#include "fd-net-device-helper.h"
+
 #include "ns3/attribute.h"
-#include "ns3/fd-net-device-helper.h"
 #include "ns3/fd-net-device.h"
 #include "ns3/net-device-container.h"
 #include "ns3/node-container.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/helper/fd-net-device-helper.cc ns-3.40/src/fd-net-device/helper/fd-net-device-helper.cc
--- ns-3.39/src/fd-net-device/helper/fd-net-device-helper.cc	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/helper/fd-net-device-helper.cc	2023-09-27 13:30:37.646839100 -0700
@@ -199,7 +199,7 @@
 {
     NetDeviceContainer devs;
 
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); i++)
+    for (auto i = c.Begin(); i != c.End(); i++)
     {
         devs.Add(InstallPriv(*i));
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/helper/netmap-net-device-helper.h ns-3.40/src/fd-net-device/helper/netmap-net-device-helper.h
--- ns-3.39/src/fd-net-device/helper/netmap-net-device-helper.h	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/helper/netmap-net-device-helper.h	2023-09-27 13:30:37.646839100 -0700
@@ -20,8 +20,9 @@
 #ifndef NETMAP_NET_DEVICE_HELPER_H
 #define NETMAP_NET_DEVICE_HELPER_H
 
+#include "fd-net-device-helper.h"
+
 #include "ns3/attribute.h"
-#include "ns3/fd-net-device-helper.h"
 #include "ns3/fd-net-device.h"
 #include "ns3/net-device-container.h"
 #include "ns3/netmap-net-device.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/helper/tap-device-creator.cc ns-3.40/src/fd-net-device/helper/tap-device-creator.cc
--- ns-3.39/src/fd-net-device/helper/tap-device-creator.cc	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/helper/tap-device-creator.cc	2023-09-27 13:30:37.646839100 -0700
@@ -216,8 +216,8 @@
 int
 CreateTap(char* deviceName,
           const char* mac,
-          const int ifftap,
-          const int iffpi,
+          bool ifftap,
+          bool iffpi,
           const char* ip4,
           const char* netmask,
           const char* ip6,
@@ -293,8 +293,8 @@
     char* mac = nullptr;
     char* netmask = nullptr;
     char* path = nullptr;
-    int tap = false;
-    int pi = false;
+    bool tap = false;
+    bool pi = false;
     int prefix = -1;
 
     while ((c = getopt(argc, argv, "vd:i:m:n:I:P:thp:")) != -1)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/helper/tap-fd-net-device-helper.cc ns-3.40/src/fd-net-device/helper/tap-fd-net-device-helper.cc
--- ns-3.39/src/fd-net-device/helper/tap-fd-net-device-helper.cc	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/helper/tap-fd-net-device-helper.cc	2023-09-27 13:30:37.646839100 -0700
@@ -22,7 +22,6 @@
 #include "ns3/abort.h"
 #include "ns3/config.h"
 #include "ns3/fd-net-device.h"
-#include "ns3/internet-module.h"
 #include "ns3/log.h"
 #include "ns3/names.h"
 #include "ns3/object-factory.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/model/dpdk-net-device.cc ns-3.40/src/fd-net-device/model/dpdk-net-device.cc
--- ns-3.39/src/fd-net-device/model/dpdk-net-device.cc	2023-07-05 14:23:47.793427200 -0700
+++ ns-3.40/src/fd-net-device/model/dpdk-net-device.cc	2023-09-27 13:30:37.646839100 -0700
@@ -144,14 +144,11 @@
         /* print link status if flag set */
         if (printFlag == 1)
         {
-            if (link.link_status)
+            if (!link.link_status)
             {
-                continue;
-            }
-            else
-            {
-                printf("Port %d Link Down\n", m_portId);
+                NS_LOG_INFO("Port " << +m_portId << " Link Down");
             }
+
             continue;
         }
         /* clear allPortsUp flag if any link down */
@@ -186,7 +183,7 @@
 {
     if (signum == SIGINT || signum == SIGTERM)
     {
-        printf("\n\nSignal %d received, preparing to exit...\n", signum);
+        NS_LOG_INFO("Signal " << signum << " received, preparing to exit...");
         m_forceQuit = true;
     }
 }
@@ -260,7 +257,7 @@
     command.append(dpdkDriver);
     command.append(" ");
     command.append(m_deviceName);
-    printf("Executing: %s\n", command.c_str());
+    NS_LOG_INFO("Executing: " << command);
     if (system(command.c_str()))
     {
         rte_exit(EXIT_FAILURE, "Execution failed - bye\n");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/fd-net-device/model/fd-net-device.cc ns-3.40/src/fd-net-device/model/fd-net-device.cc
--- ns-3.39/src/fd-net-device/model/fd-net-device.cc	2023-07-05 14:23:47.797427200 -0700
+++ ns-3.40/src/fd-net-device/model/fd-net-device.cc	2023-09-27 13:30:37.646839100 -0700
@@ -61,7 +61,7 @@
 {
     NS_LOG_FUNCTION(this);
 
-    uint8_t* buf = (uint8_t*)malloc(m_bufferSize);
+    auto buf = (uint8_t*)malloc(m_bufferSize);
     NS_ABORT_MSG_IF(buf == nullptr, "malloc() failed");
 
     NS_LOG_LOGIC("Calling read on fd " << m_fd);
@@ -350,7 +350,7 @@
 AddPIHeader(uint8_t*& buf, size_t& len)
 {
     // Synthesize PI header for our friend the kernel
-    uint8_t* buf2 = (uint8_t*)malloc(len + 4);
+    auto buf2 = (uint8_t*)malloc(len + 4);
     memcpy(buf2 + 4, buf, len);
     len += 4;
 
@@ -617,7 +617,7 @@
 
     NS_LOG_LOGIC("calling write");
 
-    size_t len = (size_t)packet->GetSize();
+    auto len = (size_t)packet->GetSize();
     uint8_t* buffer = AllocateBuffer(len);
     if (!buffer)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/examples/flowmon-parse-results.py ns-3.40/src/flow-monitor/examples/flowmon-parse-results.py
--- ns-3.39/src/flow-monitor/examples/flowmon-parse-results.py	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/examples/flowmon-parse-results.py	2023-09-27 13:30:37.646839100 -0700
@@ -179,23 +179,23 @@
 
 
 def main(argv):
-    file_obj = open(argv[1])
-    print("Reading XML file ", end=" ")
+    with open(argv[1], encoding="utf-8") as file_obj:
+        print("Reading XML file ", end=" ")
 
-    sys.stdout.flush()
-    level = 0
-    sim_list = []
-    for event, elem in ElementTree.iterparse(file_obj, events=("start", "end")):
-        if event == "start":
-            level += 1
-        if event == "end":
-            level -= 1
-            if level == 0 and elem.tag == 'FlowMonitor':
-                sim = Simulation(elem)
-                sim_list.append(sim)
-                elem.clear() # won't need this any more
-                sys.stdout.write(".")
-                sys.stdout.flush()
+        sys.stdout.flush()
+        level = 0
+        sim_list = []
+        for event, elem in ElementTree.iterparse(file_obj, events=("start", "end")):
+            if event == "start":
+                level += 1
+            if event == "end":
+                level -= 1
+                if level == 0 and elem.tag == 'FlowMonitor':
+                    sim = Simulation(elem)
+                    sim_list.append(sim)
+                    elem.clear() # won't need this any more
+                    sys.stdout.write(".")
+                    sys.stdout.flush()
     print(" done.")
 
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/helper/flow-monitor-helper.cc ns-3.40/src/flow-monitor/helper/flow-monitor-helper.cc
--- ns-3.39/src/flow-monitor/helper/flow-monitor-helper.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/helper/flow-monitor-helper.cc	2023-09-27 13:30:37.646839100 -0700
@@ -112,7 +112,7 @@
 Ptr<FlowMonitor>
 FlowMonitorHelper::Install(NodeContainer nodes)
 {
-    for (NodeContainer::Iterator i = nodes.Begin(); i != nodes.End(); ++i)
+    for (auto i = nodes.Begin(); i != nodes.End(); ++i)
     {
         Ptr<Node> node = *i;
         if (node->GetObject<Ipv4L3Protocol>() || node->GetObject<Ipv6L3Protocol>())
@@ -126,7 +126,7 @@
 Ptr<FlowMonitor>
 FlowMonitorHelper::InstallAll()
 {
-    for (NodeList::Iterator i = NodeList::Begin(); i != NodeList::End(); ++i)
+    for (auto i = NodeList::Begin(); i != NodeList::End(); ++i)
     {
         Ptr<Node> node = *i;
         if (node->GetObject<Ipv4L3Protocol>() || node->GetObject<Ipv6L3Protocol>())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/flow-monitor.cc ns-3.40/src/flow-monitor/model/flow-monitor.cc
--- ns-3.39/src/flow-monitor/model/flow-monitor.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/flow-monitor.cc	2023-09-27 13:30:37.646839100 -0700
@@ -102,9 +102,7 @@
     NS_LOG_FUNCTION(this);
     Simulator::Cancel(m_startEvent);
     Simulator::Cancel(m_stopEvent);
-    for (std::list<Ptr<FlowClassifier>>::iterator iter = m_classifiers.begin();
-         iter != m_classifiers.end();
-         iter++)
+    for (auto iter = m_classifiers.begin(); iter != m_classifiers.end(); iter++)
     {
         *iter = nullptr;
     }
@@ -120,8 +118,7 @@
 FlowMonitor::GetStatsForFlow(FlowId flowId)
 {
     NS_LOG_FUNCTION(this);
-    FlowStatsContainerI iter;
-    iter = m_flowStats.find(flowId);
+    auto iter = m_flowStats.find(flowId);
     if (iter == m_flowStats.end())
     {
         FlowMonitor::FlowStats& ref = m_flowStats[flowId];
@@ -191,7 +188,7 @@
         return;
     }
     std::pair<FlowId, FlowPacketId> key(flowId, packetId);
-    TrackedPacketMap::iterator tracked = m_trackedPackets.find(key);
+    auto tracked = m_trackedPackets.find(key);
     if (tracked == m_trackedPackets.end())
     {
         NS_LOG_WARN("Received packet forward report (flowId="
@@ -218,7 +215,7 @@
         NS_LOG_DEBUG("FlowMonitor not enabled; returning");
         return;
     }
-    TrackedPacketMap::iterator tracked = m_trackedPackets.find(std::make_pair(flowId, packetId));
+    auto tracked = m_trackedPackets.find(std::make_pair(flowId, packetId));
     if (tracked == m_trackedPackets.end())
     {
         NS_LOG_WARN("Received packet last-tx report (flowId="
@@ -302,7 +299,7 @@
     NS_LOG_DEBUG("++stats.packetsDropped["
                  << reasonCode << "]; // becomes: " << stats.packetsDropped[reasonCode]);
 
-    TrackedPacketMap::iterator tracked = m_trackedPackets.find(std::make_pair(flowId, packetId));
+    auto tracked = m_trackedPackets.find(std::make_pair(flowId, packetId));
     if (tracked != m_trackedPackets.end())
     {
         // we don't need to track this packet anymore
@@ -325,13 +322,12 @@
     NS_LOG_FUNCTION(this << maxDelay.As(Time::S));
     Time now = Simulator::Now();
 
-    for (TrackedPacketMap::iterator iter = m_trackedPackets.begin();
-         iter != m_trackedPackets.end();)
+    for (auto iter = m_trackedPackets.begin(); iter != m_trackedPackets.end();)
     {
         if (now - iter->second.lastSeenTime >= maxDelay)
         {
             // packet is considered lost, add it to the loss statistics
-            FlowStatsContainerI flow = m_flowStats.find(iter->first.first);
+            auto flow = m_flowStats.find(iter->first.first);
             NS_ASSERT(flow != m_flowStats.end());
             flow->second.lostPackets++;
 
@@ -444,7 +440,7 @@
     indent += 2;
     os << std::string(indent, ' ') << "<FlowStats>\n";
     indent += 2;
-    for (FlowStatsContainerCI flowI = m_flowStats.begin(); flowI != m_flowStats.end(); flowI++)
+    for (auto flowI = m_flowStats.begin(); flowI != m_flowStats.end(); flowI++)
     {
         os << std::string(indent, ' ');
 #define ATTRIB(name) << " " #name "=\"" << flowI->second.name << "\""
@@ -492,9 +488,7 @@
     indent -= 2;
     os << std::string(indent, ' ') << "</FlowStats>\n";
 
-    for (std::list<Ptr<FlowClassifier>>::iterator iter = m_classifiers.begin();
-         iter != m_classifiers.end();
-         iter++)
+    for (auto iter = m_classifiers.begin(); iter != m_classifiers.end(); iter++)
     {
         (*iter)->SerializeToXmlStream(os, indent);
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/flow-monitor.h ns-3.40/src/flow-monitor/model/flow-monitor.h
--- ns-3.39/src/flow-monitor/model/flow-monitor.h	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/flow-monitor.h	2023-09-27 13:30:37.646839100 -0700
@@ -20,9 +20,10 @@
 #ifndef FLOW_MONITOR_H
 #define FLOW_MONITOR_H
 
+#include "flow-classifier.h"
+#include "flow-probe.h"
+
 #include "ns3/event-id.h"
-#include "ns3/flow-classifier.h"
-#include "ns3/flow-probe.h"
 #include "ns3/histogram.h"
 #include "ns3/nstime.h"
 #include "ns3/object.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/flow-probe.cc ns-3.40/src/flow-monitor/model/flow-probe.cc
--- ns-3.39/src/flow-monitor/model/flow-probe.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/flow-probe.cc	2023-09-27 13:30:37.646839100 -0700
@@ -17,9 +17,9 @@
 // Author: Gustavo J. A. M. Carneiro  <gjc@inescporto.pt> <gjcarneiro@gmail.com>
 //
 
-#include "ns3/flow-probe.h"
+#include "flow-probe.h"
 
-#include "ns3/flow-monitor.h"
+#include "flow-monitor.h"
 
 namespace ns3
 {
@@ -88,7 +88,7 @@
 
     indent += 2;
 
-    for (Stats::const_iterator iter = m_stats.begin(); iter != m_stats.end(); iter++)
+    for (auto iter = m_stats.begin(); iter != m_stats.end(); iter++)
     {
         os << std::string(indent, ' ');
         os << "<FlowStats "
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/flow-probe.h ns-3.40/src/flow-monitor/model/flow-probe.h
--- ns-3.39/src/flow-monitor/model/flow-probe.h	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/flow-probe.h	2023-09-27 13:30:37.646839100 -0700
@@ -20,7 +20,8 @@
 #ifndef FLOW_PROBE_H
 #define FLOW_PROBE_H
 
-#include "ns3/flow-classifier.h"
+#include "flow-classifier.h"
+
 #include "ns3/nstime.h"
 #include "ns3/object.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/ipv4-flow-classifier.cc ns-3.40/src/flow-monitor/model/ipv4-flow-classifier.cc
--- ns-3.39/src/flow-monitor/model/ipv4-flow-classifier.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/ipv4-flow-classifier.cc	2023-09-27 13:30:37.646839100 -0700
@@ -145,8 +145,7 @@
     tuple.destinationPort = dstPort;
 
     // try to insert the tuple, but check if it already exists
-    std::pair<std::map<FiveTuple, FlowId>::iterator, bool> insert =
-        m_flowMap.insert(std::pair<FiveTuple, FlowId>(tuple, 0));
+    auto insert = m_flowMap.insert(std::pair<FiveTuple, FlowId>(tuple, 0));
 
     // if the insertion succeeded, we need to assign this tuple a new flow identifier
     if (insert.second)
@@ -163,9 +162,8 @@
 
     // increment the counter of packets with the same DSCP value
     Ipv4Header::DscpType dscp = ipHeader.GetDscp();
-    std::pair<std::map<Ipv4Header::DscpType, uint32_t>::iterator, bool> dscpInserter =
-        m_flowDscpMap[insert.first->second].insert(
-            std::pair<Ipv4Header::DscpType, uint32_t>(dscp, 1));
+    auto dscpInserter = m_flowDscpMap[insert.first->second].insert(
+        std::pair<Ipv4Header::DscpType, uint32_t>(dscp, 1));
 
     // if the insertion did not succeed, we need to increment the counter
     if (!dscpInserter.second)
@@ -182,9 +180,7 @@
 Ipv4FlowClassifier::FiveTuple
 Ipv4FlowClassifier::FindFlow(FlowId flowId) const
 {
-    for (std::map<FiveTuple, FlowId>::const_iterator iter = m_flowMap.begin();
-         iter != m_flowMap.end();
-         iter++)
+    for (auto iter = m_flowMap.begin(); iter != m_flowMap.end(); iter++)
     {
         if (iter->second == flowId)
         {
@@ -206,8 +202,7 @@
 std::vector<std::pair<Ipv4Header::DscpType, uint32_t>>
 Ipv4FlowClassifier::GetDscpCounts(FlowId flowId) const
 {
-    std::map<FlowId, std::map<Ipv4Header::DscpType, uint32_t>>::const_iterator flow =
-        m_flowDscpMap.find(flowId);
+    auto flow = m_flowDscpMap.find(flowId);
 
     if (flow == m_flowDscpMap.end())
     {
@@ -227,9 +222,7 @@
     os << "<Ipv4FlowClassifier>\n";
 
     indent += 2;
-    for (std::map<FiveTuple, FlowId>::const_iterator iter = m_flowMap.begin();
-         iter != m_flowMap.end();
-         iter++)
+    for (auto iter = m_flowMap.begin(); iter != m_flowMap.end(); iter++)
     {
         Indent(os, indent);
         os << "<Flow flowId=\"" << iter->second << "\""
@@ -240,14 +233,11 @@
            << " destinationPort=\"" << iter->first.destinationPort << "\">\n";
 
         indent += 2;
-        std::map<FlowId, std::map<Ipv4Header::DscpType, uint32_t>>::const_iterator flow =
-            m_flowDscpMap.find(iter->second);
+        auto flow = m_flowDscpMap.find(iter->second);
 
         if (flow != m_flowDscpMap.end())
         {
-            for (std::map<Ipv4Header::DscpType, uint32_t>::const_iterator i = flow->second.begin();
-                 i != flow->second.end();
-                 i++)
+            for (auto i = flow->second.begin(); i != flow->second.end(); i++)
             {
                 Indent(os, indent);
                 os << "<Dscp value=\"0x" << std::hex << static_cast<uint32_t>(i->first) << "\""
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/ipv4-flow-classifier.h ns-3.40/src/flow-monitor/model/ipv4-flow-classifier.h
--- ns-3.39/src/flow-monitor/model/ipv4-flow-classifier.h	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/ipv4-flow-classifier.h	2023-09-27 13:30:37.646839100 -0700
@@ -20,7 +20,8 @@
 #ifndef IPV4_FLOW_CLASSIFIER_H
 #define IPV4_FLOW_CLASSIFIER_H
 
-#include "ns3/flow-classifier.h"
+#include "flow-classifier.h"
+
 #include "ns3/ipv4-header.h"
 
 #include <map>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/ipv4-flow-probe.cc ns-3.40/src/flow-monitor/model/ipv4-flow-probe.cc
--- ns-3.39/src/flow-monitor/model/ipv4-flow-probe.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/ipv4-flow-probe.cc	2023-09-27 13:30:37.646839100 -0700
@@ -17,12 +17,13 @@
 // Author: Gustavo J. A. M. Carneiro  <gjc@inescporto.pt> <gjcarneiro@gmail.com>
 //
 
-#include "ns3/ipv4-flow-probe.h"
+#include "ipv4-flow-probe.h"
+
+#include "flow-monitor.h"
+#include "ipv4-flow-classifier.h"
 
 #include "ns3/config.h"
 #include "ns3/flow-id-tag.h"
-#include "ns3/flow-monitor.h"
-#include "ns3/ipv4-flow-classifier.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/packet.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/ipv4-flow-probe.h ns-3.40/src/flow-monitor/model/ipv4-flow-probe.h
--- ns-3.39/src/flow-monitor/model/ipv4-flow-probe.h	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/ipv4-flow-probe.h	2023-09-27 13:30:37.646839100 -0700
@@ -20,8 +20,9 @@
 #ifndef IPV4_FLOW_PROBE_H
 #define IPV4_FLOW_PROBE_H
 
-#include "ns3/flow-probe.h"
-#include "ns3/ipv4-flow-classifier.h"
+#include "flow-probe.h"
+#include "ipv4-flow-classifier.h"
+
 #include "ns3/ipv4-l3-protocol.h"
 #include "ns3/queue-item.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/ipv6-flow-classifier.cc ns-3.40/src/flow-monitor/model/ipv6-flow-classifier.cc
--- ns-3.39/src/flow-monitor/model/ipv6-flow-classifier.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/ipv6-flow-classifier.cc	2023-09-27 13:30:37.646839100 -0700
@@ -146,8 +146,7 @@
     tuple.destinationPort = dstPort;
 
     // try to insert the tuple, but check if it already exists
-    std::pair<std::map<FiveTuple, FlowId>::iterator, bool> insert =
-        m_flowMap.insert(std::pair<FiveTuple, FlowId>(tuple, 0));
+    auto insert = m_flowMap.insert(std::pair<FiveTuple, FlowId>(tuple, 0));
 
     // if the insertion succeeded, we need to assign this tuple a new flow identifier
     if (insert.second)
@@ -164,9 +163,8 @@
 
     // increment the counter of packets with the same DSCP value
     Ipv6Header::DscpType dscp = ipHeader.GetDscp();
-    std::pair<std::map<Ipv6Header::DscpType, uint32_t>::iterator, bool> dscpInserter =
-        m_flowDscpMap[insert.first->second].insert(
-            std::pair<Ipv6Header::DscpType, uint32_t>(dscp, 1));
+    auto dscpInserter = m_flowDscpMap[insert.first->second].insert(
+        std::pair<Ipv6Header::DscpType, uint32_t>(dscp, 1));
 
     // if the insertion did not succeed, we need to increment the counter
     if (!dscpInserter.second)
@@ -183,9 +181,7 @@
 Ipv6FlowClassifier::FiveTuple
 Ipv6FlowClassifier::FindFlow(FlowId flowId) const
 {
-    for (std::map<FiveTuple, FlowId>::const_iterator iter = m_flowMap.begin();
-         iter != m_flowMap.end();
-         iter++)
+    for (auto iter = m_flowMap.begin(); iter != m_flowMap.end(); iter++)
     {
         if (iter->second == flowId)
         {
@@ -207,8 +203,7 @@
 std::vector<std::pair<Ipv6Header::DscpType, uint32_t>>
 Ipv6FlowClassifier::GetDscpCounts(FlowId flowId) const
 {
-    std::map<FlowId, std::map<Ipv6Header::DscpType, uint32_t>>::const_iterator flow =
-        m_flowDscpMap.find(flowId);
+    auto flow = m_flowDscpMap.find(flowId);
 
     if (flow == m_flowDscpMap.end())
     {
@@ -228,9 +223,7 @@
     os << "<Ipv6FlowClassifier>\n";
 
     indent += 2;
-    for (std::map<FiveTuple, FlowId>::const_iterator iter = m_flowMap.begin();
-         iter != m_flowMap.end();
-         iter++)
+    for (auto iter = m_flowMap.begin(); iter != m_flowMap.end(); iter++)
     {
         Indent(os, indent);
         os << "<Flow flowId=\"" << iter->second << "\""
@@ -241,14 +234,11 @@
            << " destinationPort=\"" << iter->first.destinationPort << "\">\n";
 
         indent += 2;
-        std::map<FlowId, std::map<Ipv6Header::DscpType, uint32_t>>::const_iterator flow =
-            m_flowDscpMap.find(iter->second);
+        auto flow = m_flowDscpMap.find(iter->second);
 
         if (flow != m_flowDscpMap.end())
         {
-            for (std::map<Ipv6Header::DscpType, uint32_t>::const_iterator i = flow->second.begin();
-                 i != flow->second.end();
-                 i++)
+            for (auto i = flow->second.begin(); i != flow->second.end(); i++)
             {
                 Indent(os, indent);
                 os << "<Dscp value=\"0x" << std::hex << static_cast<uint32_t>(i->first) << "\""
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/ipv6-flow-classifier.h ns-3.40/src/flow-monitor/model/ipv6-flow-classifier.h
--- ns-3.39/src/flow-monitor/model/ipv6-flow-classifier.h	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/ipv6-flow-classifier.h	2023-09-27 13:30:37.646839100 -0700
@@ -21,7 +21,8 @@
 #ifndef IPV6_FLOW_CLASSIFIER_H
 #define IPV6_FLOW_CLASSIFIER_H
 
-#include "ns3/flow-classifier.h"
+#include "flow-classifier.h"
+
 #include "ns3/ipv6-header.h"
 
 #include <map>
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/ipv6-flow-probe.cc ns-3.40/src/flow-monitor/model/ipv6-flow-probe.cc
--- ns-3.39/src/flow-monitor/model/ipv6-flow-probe.cc	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/ipv6-flow-probe.cc	2023-09-27 13:30:37.646839100 -0700
@@ -18,12 +18,13 @@
 // Modifications: Tommaso Pecorella <tommaso.pecorella@unifi.it>
 //
 
-#include "ns3/ipv6-flow-probe.h"
+#include "ipv6-flow-probe.h"
+
+#include "flow-monitor.h"
+#include "ipv6-flow-classifier.h"
 
 #include "ns3/config.h"
 #include "ns3/flow-id-tag.h"
-#include "ns3/flow-monitor.h"
-#include "ns3/ipv6-flow-classifier.h"
 #include "ns3/log.h"
 #include "ns3/node.h"
 #include "ns3/packet.h"
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/flow-monitor/model/ipv6-flow-probe.h ns-3.40/src/flow-monitor/model/ipv6-flow-probe.h
--- ns-3.39/src/flow-monitor/model/ipv6-flow-probe.h	2023-07-05 14:23:47.825427300 -0700
+++ ns-3.40/src/flow-monitor/model/ipv6-flow-probe.h	2023-09-27 13:30:37.646839100 -0700
@@ -21,8 +21,9 @@
 #ifndef IPV6_FLOW_PROBE_H
 #define IPV6_FLOW_PROBE_H
 
-#include "ns3/flow-probe.h"
-#include "ns3/ipv6-flow-classifier.h"
+#include "flow-probe.h"
+#include "ipv6-flow-classifier.h"
+
 #include "ns3/ipv6-l3-protocol.h"
 #include "ns3/queue-item.h"
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/internet/helper/internet-stack-helper.cc ns-3.40/src/internet/helper/internet-stack-helper.cc
--- ns-3.39/src/internet/helper/internet-stack-helper.cc	2023-07-05 14:23:47.837427400 -0700
+++ ns-3.40/src/internet/helper/internet-stack-helper.cc	2023-09-27 13:30:37.650839000 -0700
@@ -223,7 +223,7 @@
 InternetStackHelper::AssignStreams(NodeContainer c, int64_t stream)
 {
     int64_t currentStream = stream;
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Ptr<Node> node = *i;
         Ptr<GlobalRouter> router = node->GetObject<GlobalRouter>();
@@ -267,7 +267,7 @@
 void
 InternetStackHelper::Install(NodeContainer c) const
 {
-    for (NodeContainer::Iterator i = c.Begin(); i != c.End(); ++i)
+    for (auto i = c.Begin(); i != c.End(); ++i)
     {
         Install(*i);
     }
@@ -404,11 +404,11 @@
 bool
 InternetStackHelper::PcapHooked(Ptr<Ipv4> ipv4)
 {
-    for (InterfaceFileMapIpv4::const_iterator i = g_interfaceFileMapIpv4.begin();
-         i != g_interfaceFileMapIpv4.end();
-         ++i)
+    auto id = ipv4->GetObject<Node>()->GetId();
+
+    for (auto i = g_interfaceFileMapIpv4.begin(); i != g_interfaceFileMapIpv4.end(); ++i)
     {
-        if ((*i).first.first == ipv4->GetObject<Node>()->GetId())
+        if ((*i).first.first == id)
         {
             return true;
         }
@@ -510,11 +510,11 @@
 bool
 InternetStackHelper::PcapHooked(Ptr<Ipv6> ipv6)
 {
-    for (InterfaceFileMapIpv6::const_iterator i = g_interfaceFileMapIpv6.begin();
-         i != g_interfaceFileMapIpv6.end();
-         ++i)
+    auto id = ipv6->GetObject<Node>()->GetId();
+
+    for (auto i = g_interfaceFileMapIpv6.begin(); i != g_interfaceFileMapIpv6.end(); ++i)
     {
-        if ((*i).first.first == ipv6->GetObject<Node>()->GetId())
+        if ((*i).first.first == id)
         {
             return true;
         }
@@ -774,11 +774,11 @@
 bool
 InternetStackHelper::AsciiHooked(Ptr<Ipv4> ipv4)
 {
-    for (InterfaceStreamMapIpv4::const_iterator i = g_interfaceStreamMapIpv4.begin();
-         i != g_interfaceStreamMapIpv4.end();
-         ++i)
+    auto id = ipv4->GetObject<Node>()->GetId();
+
+    for (auto i = g_interfaceStreamMapIpv4.begin(); i != g_interfaceStreamMapIpv4.end(); ++i)
     {
-        if ((*i).first.first == ipv4->GetObject<Node>()->GetId())
+        if ((*i).first.first == id)
         {
             return true;
         }
@@ -1118,11 +1118,11 @@
 bool
 InternetStackHelper::AsciiHooked(Ptr<Ipv6> ipv6)
 {
-    for (InterfaceStreamMapIpv6::const_iterator i = g_interfaceStreamMapIpv6.begin();
-         i != g_interfaceStreamMapIpv6.end();
-         ++i)
+    auto id = ipv6->GetObject<Node>()->GetId();
+
+    for (auto i = g_interfaceStreamMapIpv6.begin(); i != g_interfaceStreamMapIpv6.end(); ++i)
     {
-        if ((*i).first.first == ipv6->GetObject<Node>()->GetId())
+        if ((*i).first.first == id)
         {
             return true;
         }
